<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\Xclass\Templavoila;

if (\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded('templavoila')) {
    require_once(
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('templavoila', 'mod1/class.tx_templavoila_mod1_specialdoktypes.php')
    );
} else {
    require_once(
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('imia_pageteaser', 'Classes/Dummy/Templavoila/tx_templavoila_mod1_specialdoktypes.php')
    );
}

/**
 * @package     imia_pageteaser
 * @subpackage  Xclass
 * @author      David Frerich <d.frerich@imia.de>
 */
class SpecialDoktypes extends \tx_templavoila_mod1_specialdoktypes
{
    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_103($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_104($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

	/**
	 * @param array $pageRecord
	 * @return string
	 */
	public function renderDoktype_111($pageRecord)
    {
		$flashMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(
			'TYPO3\CMS\Core\Messaging\FlashMessage',
			$this->translate('doktype_111_notice'),
			'',
			\TYPO3\CMS\Core\Messaging\FlashMessage::INFO
		);

		return $flashMessage->render();
	}

	/**
	 * @param array $pageRecord
	 * @return string
	 */
	public function renderDoktype_112($pageRecord)
    {
		$flashMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(
			'TYPO3\CMS\Core\Messaging\FlashMessage',
			$this->translate('doktype_112_notice'),
			'',
			\TYPO3\CMS\Core\Messaging\FlashMessage::INFO
		);

		switch ($pageRecord['urltype']) {
			case 4:
				$url = 'https://' . $pageRecord['url'];
			break;
			default:
                // Check if URI scheme already present. We support only Internet-specific notation,
                // others are not relevant for us (see http://www.ietf.org/rfc/rfc3986.txt for details)
				if (preg_match('/^[a-z]+[a-z0-9\+\.\-]*:\/\//i', $pageRecord['url'])) {
                    // Do not add any other scheme
					$url = $pageRecord['url'];
					break;
				}
				// fall through
			case 1:
				$url = 'http://' . $pageRecord['url'];
			break;
		}

        $urlInfo = ' <br><br><strong><a href="' . $url . '" target="_new">' .
            htmlspecialchars(sprintf($this->translate('doktype_111_url'), $url)) . '</a></strong>';

		return $flashMessage->render() . $urlInfo;
	}

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_113($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_114($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

	/**
	 * @param array $pageRecord
	 * @return string
	 */
	public function renderDoktype_115($pageRecord)
    {
		$flashMessage = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(
			'TYPO3\CMS\Core\Messaging\FlashMessage',
			$this->translate('doktype_115_notice'),
			'',
			\TYPO3\CMS\Core\Messaging\FlashMessage::INFO
		);

		return $flashMessage->render();
	}

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_123($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_124($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_133($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_134($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_143($pageRecord)
    {
        return self::renderDoktype_3($pageRecord);
    }

    /**
     * @param array $pageRecord
     * @return string
     */
    public function renderDoktype_144($pageRecord)
    {
        return self::renderDoktype_4($pageRecord);
    }

    /**
     * @param string $key
     * @param string $ext
     * @param string $path
     * @param string $file
     * @return string
     */
    protected function translate($key, $ext = 'imia_pageteaser', $path = 'Resources/Private/Language', $file = 'Backend.xlf')
    {
        return $GLOBALS['LANG']->sL('LLL:EXT:' . $ext . '/' . ($path ? $path . '/' : '') . $file . ':' . $key);
    }
}